// Emacs style mode select   -*- C++ -*-
//-----------------------------------------------------------------------------
//
// $Id: query_thread.h 1212 2009-01-02 00:50:06Z ghostlydeath $
//
// Copyright (C) 2006-2009 by The Odamex Team.
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// DESCRIPTION:
//	Multi-Threaded Server Queries
//	AUTHOR:	Mike Wood (Hyper_Eye)
//
//-----------------------------------------------------------------------------

#ifndef QUERY_THREAD_H_INCLUDED
#define QUERY_THREAD_H_INCLUDED

#include <wx/thread.h>
#include <wx/event.h>

#include "net_packet.h"

DECLARE_EVENT_TYPE(wxEVT_THREAD_WORKER_SIGNAL, -1);

#define NUM_THREADS 10

class QueryThread : public wxThread
{
    public:

        QueryThread();
        QueryThread(wxEvtHandler *EventHandler, Server *QueryServer, wxInt32 ServerIndex, wxUint32 ServerTimeout) : wxThread(wxTHREAD_JOINABLE),
            m_EventHandler(EventHandler), m_QueryServer(QueryServer), m_ServerIndex(ServerIndex), m_ServerTimeout(ServerTimeout) {}

        virtual void *Entry();

    private:
        wxEvtHandler  *m_EventHandler;
        Server        *m_QueryServer;
        wxInt32       m_ServerIndex;
        wxUint32      m_ServerTimeout;

};

#endif // QUERY_THREAD_H_INCLUDED
